<template>
  <SinglePane class="logchains-list">
    <div class="logchain-list__tabs">
      <ObTabs
        v-model="currentTab"
        :items="tabsItems"
        :no-border="true"
        value-exp="uuid"
        data-qa="logchainListTabs"
      />
    </div>
    <ObTable
      :columns="columns"
      :functionalPanel="true"
      :show-add-button="true"
      add-button-text="Создать"
      :remote-opt="{
        method: getLogchains
      }"
      :remote-trigger="currentTab.uuid"
      data-qa="logchainListTable"
      @select="onSelection"
      @add="onAddLogchain"
      ref="obTable"
      is-fixed-header
    >
      <template v-slot:number="{ data }">
        <div class="number">
          <ob-tooltip position="top-start" v-if="data.item.isManual">
            <div slot="content">
              <div class="tooltip">
                Cоздано вручную
              </div>
            </div>
            <i class="icon hand" />
          </ob-tooltip>
          <span>
            {{ data.item.number }}
          </span>
        </div>
      </template>
      <template v-slot:modality="{ data }">
        <span v-html="getModality(data.item.points)"></span>
      </template>
      <template v-slot:route="{ data }">
        <span v-for="(item, index) in data.item.points" :key="item.uuid">
          <i :class="['icon', item.resourceClassUuid ? $options.iconMap[item.resourceClassUuid] : '', item.isMain ? 'main' : '']" v-if="index > 0"/>
          {{ item.locationTitle }}
        </span>
      </template>
      <template v-slot:date="{ data }">
        {{ data.item.date }}
      </template>
      <template v-slot:ready="{ data }">
        <ob-tooltip v-if="data.item.isValid" position="top-end">
          <div slot="content">
            <div class="tooltip">
              Черновик логцепочки готов к публикации. Нажмите, чтобы опубликовать.
            </div>
          </div>
          <i class="icon route-unloading" @click="onPublish(data.item)" />
        </ob-tooltip>
      </template>
      <template v-slot:actions="{ data }">
        <ob-menu-dropdown
          :items="[{title: 'Удалить', className: 'color-error', icon: 'trash', method: () => onClickAction(data), description: 'Удалить черновик логцепочки без возможности восстановления'}]"
          trigger="click"
        >
        </ob-menu-dropdown>
      </template>
      <template slot="noneContent">
        <template v-if="currentTab && currentTab.uuid === 'CAR'">
          <div class="title">Здесь будут черновики <i class="icon truck"/>  логцепочек</div>
          <div>
            Создайте <router-link tag="a" :to="{path: '/logchain-item/new-logchain', query: {resourceClassUuid: this.currentTab.resourceClassUuid}}">новую логцепочку</router-link>
          </div>
        </template>
        <template v-else-if="currentTab && currentTab.uuid === 'CONTAINER'">
          <div class="title">Здесь будут черновики <i class="icon truck"/>  логцепочек</div>
          <div>
            Создайте <router-link tag="a" :to="{path: '/logchain-item/new-logchain', query: {resourceClassUuid: this.currentTab.resourceClassUuid}}">новую логцепочку</router-link>
          </div>
        </template>
        <template v-else-if="currentTab && currentTab.uuid === 'WAGON'">
          <div class="title">Здесь будут черновики <i class="icon truck"/>  логцепочек</div>
          <div>
            Создайте <router-link tag="a" :to="{path: '/logchain-item/new-logchain', query: {resourceClassUuid: this.currentTab.resourceClassUuid}}">новую логцепочку</router-link>
          </div>
        </template>
      </template>
    </ObTable>
  </SinglePane>
</template>

<script>
  import api from '@/api'
  import moment from 'moment'
  import cloneDeep from 'clone-deep'
  import { compareValues } from "@/helpers"
  import SinglePane from 'common-components/src/obComponents/obSinglePanels'
  import ObTabs from 'common-components/src/obComponents/obTabs'
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObTooltip from 'common-components/src/obComponents/obTooltip'
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'

  const resourcesMap = {
    "CAR" :"e7519b46-faf4-11e9-8f0b-362b9e155667",
    "CONTAINER": "e7519ee8-faf4-11e9-8f0b-362b9e155667",
    "WAGON": "e7519d9e-faf4-11e9-8f0b-362b9e155667"
  }

  export default {
    name: 'logchainDraftList',

    components: {
      SinglePane,
      ObTabs,
      ObTable,
      ObTooltip,
      ObMenuDropdown,
    },

    iconMap: {
      "e7519b46-faf4-11e9-8f0b-362b9e155667": "truck-sm",
      "e7519ee8-faf4-11e9-8f0b-362b9e155667": "container",
      "e7519d9e-faf4-11e9-8f0b-362b9e155667": "train-sm"
    },

    data() {
      return {
        orderField: 'UPDATED_AT',
        orderDirection: 'DESC',
        api,
        tabsItems: [
          {
            uuid: 'CAR',
            title: 'Целые машины',
            resourceClassUuid: "e7519b46-faf4-11e9-8f0b-362b9e155667",
            qa: "logchainListTabsCar"
          },
          {
            uuid: 'CONTAINER',
            title: 'Контейнеры',
            resourceClassUuid: "e7519ee8-faf4-11e9-8f0b-362b9e155667",
            qa: "logchainListTabsContainer"
          },
          {
            uuid: 'WAGON',
            title: 'Вагоны',
            resourceClassUuid: "e7519d9e-faf4-11e9-8f0b-362b9e155667",
            qa: "logchainListTabsWagon"
          }
        ],
        currentTab: { uuid: this.$route.query.tab || 'CAR', resourceClassUuid: resourcesMap[this.$route.query.tab] || resourcesMap['CAR']},
        activeItem: ''
      }
    },

    watch: {
      currentTab: {
        handler(tab) {
          this.$router.replace({ query: { tab: tab.uuid } })
        },
        deep: true,
        immediate: true
      }
    },

    computed: {
      columns () {
        return [
          {
            title: '№ Логцепочки',
            key: 'number',
            slotName: 'number',
            width: 180
          },
          {
            title: 'модальность',
            key: 'modality',
            width: 100,
            slotName: 'modality'
          },
          {
            title: "состав маршрута",
            key: "route",
            width: 620,
            slotName: "route"
          },
          {
            title: 'дата изменения',
            key: "date",
            width: 180,
            slotName: "date"
          },
          {
            title: '',
            slotName: "ready",
            action: true,
            isToggleDisabled: true
          },
          {
            title: '',
            slotName: 'actions',
            action: true,
            isToggleDisabled: true
          }
        ]
      }
    },

    async created() {
      for (let item of this.tabsItems) {
        const count = await api.logchain.getlogchainsList({resource_class_uuid: item.resourceClassUuid, status: 'DRAFT'})
        item.title += ` ${count.totalElements}`
      }
    },

    methods: {
      onPublish(item) {
        console.log('publish ->', item);
      },

      getModality(points) {
        if (!points.length) return

        const temp = cloneDeep(points).sort(compareValues('ordinal', 'asc'))

        const set = temp.reduce((acc, item, index) => {
          if (item.resourceClassUuid) {
            if (index === 0) {
              acc.push({resourceClassUuid: item.resourceClassUuid, main: item.isMain})
            } else if (index > 0 && item.resourceClassUuid !== temp[index-1].resourceClassUuid) {
              acc.push({resourceClassUuid: item.resourceClassUuid, main: item.isMain})
            } else if (index > 0 && item.resourceClassUuid === temp[index-1].resourceClassUuid && item.isMain) {
              acc[acc.length - 1].main = true;
            }
          }
          return acc
        },[])

        let markup = ''

        if (set.length === 1) {
          set[0].main = true;
        }

        for (let i of set) {

          markup += `
            <i class="icon ${this.$options.iconMap[i.resourceClassUuid]} ${i.main ? 'main' : ''} "></i>
          `
        }

        return markup
      },

      async getLogchains({page, size, sort, query }) {
        if (sort) {
          const field = sort.split(',')[0];
          if (field === 'number') {
            this.orderDirection = sort.split(',')[1].toUpperCase();
            this.orderField = 'NUMBER'
          } else if (field === 'route') {
            this.orderDirection = sort.split(',')[1].toUpperCase();
            this.orderField = 'FIRST_POINT_TITLE'
          } else if (field === 'date') {
            this.orderDirection = sort.split(',')[1].toUpperCase();
            this.orderField = 'UPDATED_AT'
          }
        }
        try {
          let data = await api.logchain.getlogchainsList({ resource_class_uuid: this.currentTab.resourceClassUuid, status: 'DRAFT', page_number: page, page_size: size, order_field: this.orderField, order_direction: this.orderDirection, query })

          if (data.content.length) {
            data.content = data.content.map((item) => {
              item.points.sort(compareValues('ordinal', 'asc'));
              return {
                ...item,
                date: item.updatedAt ? moment(item.updatedAt).format("DD.MM.YYYY") : "Не указана"
              }
            })
          }

          return data;
        } catch (e) {
          console.error(e);
          this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
        }
      },

      onSelection(data) {
        this.activeItem = data
        this.$router.push(`/logchain-item/${data.uuid}`)
      },

      async onClickAction(data) {
        try {
          await api.logchain.deleteLogchain(data.item.uuid);
          this.$refs['obTable'].loadData({ init: true });
          this.$notification({type: 'snackbars', message: `Черновик ${data.item.number} удалён` })
        } catch (error) {
          console.error(error);
        }
      },

      onAddLogchain() {
        this.$router.push({path: '/logchain-item/new-logchain', query: {resourceClassUuid: this.currentTab.resourceClassUuid}});
      }
    },
  }
</script>

<style lang="scss" scoped>
.logchains-list {
  .container {
    width: auto;
  }

  &::v-deep {
    .ob-func-panel {
      &__control-row {
        background-color: transparent;
      }
    }
    .ob-tabs__sliding-line {
      bottom: 0;
    }

    .ob-table-inner {
      z-index: 1;
    }

    th:nth-child(1) {
      width: 180px;
    }

    th:nth-child(2) {
      width: 160px;
    }

    th:nth-child(4) {
      width: 137px;
    }

    th:nth-child(5),
    th:nth-child(6) {
      width: 50px;
      min-width: 50px;
    }

    th:nth-child(2) > .td-container {
      display: flex;
      justify-content: center;
    }

    td > .td-container {
      padding: 20px 18px;
      min-height: auto;
    }

    td:nth-child(2) > .td-container {
      display: flex;
      justify-content: center;

      i {
        margin: 0 2px;
        color: $color-blue-navy-blue;

        &.main {
          color: $green-craiola;
        }
      }
    }

    td:nth-child(3) > .td-container > div {
      width: 100%;
      display: flex;
      flex-wrap: wrap;
      align-items: center;

      span {
        display: flex;
        align-items: center;

        i {
          margin: 0 5px;
          color: $color-blue-navy-blue;

          &.main {
            color: $green-craiola;
          }
        }
      }
    }

    td:nth-child(5) {
      i {
        cursor: pointer;
      }
    }

    td:last-child {
      .td-container {
        padding: 0;
        display: none;
      }
    }

    tr:hover > td:last-child .td-container {
      display: flex;
    }

    .number {
      display: flex;
      align-items: center;

      span {
        margin-left: calc(1em + 20px);
      }

      .icon {
        margin-right: 20px;
        font-size: 12px;
        color: $color-blue-navy-blue;

        & + span {
          margin-left: 0;
        }
      }
    }

    .none-data-slot .title {
      display: flex;
      align-items: center;

      i {
        margin: 0 5px;
        position: relative;
        top: 2px;
      }
    }

    .ob-menu-dropdown-container .menu-dropdown-list__item button {
      display: flex;
      align-items: flex-start;
    }

    .ob-menu-dropdown-container .menu-dropdown-list__item button .col-left i {
      position: relative;
      top: 5px;
      font-size: 14px;
    }

    .ob-menu-dropdown-container .menu-dropdown-list__item.color-error button .col-left i:before {
      color: $color-error;
    }

    .route-unloading:before {
      color: $green-craiola;
    }
  }
}
.logchain-list__tabs {
  padding: 20px 20px 0 20px;
  position: relative;
  box-shadow: 0px 2px 10px rgba(0, 75, 200, 0.15);
  z-index: 100;
}
</style>
